local Henhouse = ...

Henhouse:register({
    DataType = "BUILDING",
    Id = _PastryPrefix .. "_HENHOUSE",
    Name = _PastryPrefix .. "_HENHOUSE_NAME",
    Description = _PastryPrefix .. "_HENHOUSE_DESC",
    BuildingType = "GENERAL",
    AssetCoreBuildingPart = _PastryPrefix .. "_HENHOUSE_PART"
})

Henhouse:dofile("scripts/compHenHouse.lua")

-- Register prefab nodes (currently only one core model)
Henhouse:registerAssetId("models/henhouse.fbx/Prefab/henhousePart", _PastryPrefix .. "_HENHOUSE_PREFAB")

-- Register the henhouse workplace part
Henhouse:register({
	DataType = "BUILDING_PART",
	Id = _PastryPrefix .. "_HENHOUSE_PART",
        BuildingZone = { ZoneEntryList = {
            { Polygon = polygon.createRectangle( {4, 4} ),
              Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } }
        }},
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = _PastryPrefix .. "_HENHOUSE_PREFAB"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "WOOD", Quantity = 5 }
		}
	},
	AssetBuildingFunction = "FUNCTION_" .. _PastryPrefix .. "_HENHOUSE"
})

Henhouse:register({
		DataType = "BUILDING_FUNCTION_WORKPLACE",
                Id = "FUNCTION_" .. _PastryPrefix .. "_HENHOUSE",
		WorkerCapacity = 1,
                RelatedJob = { Job = _PastryPrefix .. "_HEN_BREEDER", Behavior = "BEHAVIOR_WORK" },
                InputInventoryCapacity = {
			{ Resource = "WHEAT", Quantity = 2 }
                },
                ResourceListNeeded = {
                	{ Resource = "WHEAT", Quantity = 1 }
                },
                ResourceProduced = {
			{ Resource = _CommonEgg, Quantity = 4 }
                }
})

-- Register grass clearing components

Henhouse:registerPrefabComponent("models/henhouse.fbx/Prefab/henhousePart", {
	DataType = "COMP_DIRT_RECTANGLE",
	Size = {5, 5}
})

Henhouse:registerAssetId("models/henhouse.fbx/Prefab/henhousePart/step_1/door", _PastryPrefix .. "_HENHOUSE_DOOR_PREFAB")

Henhouse:registerPrefabComponent("models/henhouse.fbx/Prefab/henhousePart", {
	DataType = "COMP_BUILDING_PART",
	FeedbackComponentListToActivate = {
		{ _PastryPrefix .. "_HENHOUSE_DOOR_PREFAB", _PastryPrefix .. "_HENHOUSE_DOOR_COMP" }
	}
})

Henhouse:registerPrefabComponent("models/henhouse.fbx/Prefab/henhousePart/step_1/door", {
	DataType = _PastryPrefix .. "_HENHOUSE_DOOR_COMP",
	Enabled = false
})
Henhouse:registerPrefabComponent("models/henhouse.fbx/Prefab/henhousePart/step_1/door", {
	DataType = "COMP_GROUNDED"
})

--------------------------------------------------------------------------
function registerHen(_henNumber)
    Henhouse:registerPrefabComponent("models/henhouse.fbx/Prefab/henhousePart/poule" .. _henNumber .. "/groupMove" .. _henNumber, {
	DataType = _PastryPrefix .. "_HENHOUSE_COMP",
	Enabled = true
    })
    Henhouse:registerPrefabComponent("models/henhouse.fbx/Prefab/henhousePart/poule" .. _henNumber, {
	DataType = "COMP_GROUNDED"
    })
end

registerHen(1)
registerHen(2)
registerHen(3)
